
from Tkinter import *
import tkFileDialog
from time import sleep

g_code_code = []
def programm_schliesen():
    root.destroy()
def file_open():
    global in_mm_inch,out_mm_inch
    input_unit = in_mm_inch.get()
    output_unit = out_mm_inch.get()
    
    file_open = tkFileDialog.askopenfilename(title="NC-gerber-DATEI", \
    filetypes=[("Gerber R274X",".gdr"),("txt file",".txt"),("All files",".*")])
    gerber_text.config(state=NORMAL,font=('courier', 12, 'normal'))
    #einlesen der gerber datei .gdr dateiformat
    gerber_code = []
    fobj = open(file_open, "r") 
    #gerber_text.delete(0,END)
    for line in fobj: 
        gerber_code.append(line) 
        gerber_text.insert(END,line)
    fobj.close()
    gerber_text.config(state=DISABLED)
    global g_code_code
    g_code_code = []
    gerber_raw_XY = []
    for codeline in gerber_code:
        if codeline[0] == "X":
            gerber_raw_XY.append(codeline)
    g_code_code.append('G61 ( Exact Path)\n')
    if output_unit == 'Metric':
        g_code_code.append('G21 ( METRIC )\n')
    else :
        g_code_code.append('G20 ( INCH )\n')
    g_code_code.append('G90 ( Absolute)\n')
    # get entry fields 
    f_z = str(e_feed_z.get())
    f_xy = str(e_feed_xy.get())
    zsafe = str(e_safe_z.get())
    depth = str(e_depth.get())
    cutter_up = 'G0 Z'+zsafe + '\n'
    cutter_down = 'G1 Z'+depth+' F'+f_z+'\n'
    
    for item in gerber_raw_XY:
        linesplit = my_split(item)
        if '2' in linesplit[3]:
            g_code_code.append(cutter_up)
            xy = ('G0 X  '+getnummber(linesplit[1])+ ' Y ' +getnummber(linesplit[2])+'\n' )
            g_code_code.append(xy)
            g_code_code.append(cutter_down)
            
        if '1' in linesplit[3]:
            xy = ('G1 X '+getnummber(linesplit[1])+ ' Y ' +getnummber(linesplit[2])+' F'+f_xy+' \n' )
            g_code_code.append(xy)
    g_code_code.append(cutter_up)
    g_code_code.append('M02 ( Prog End)\n')
    
    metric_text.config(state=NORMAL,font=('courier', 12, 'normal'))
    #metric_text.delete(0,END)    
    for line in g_code_code:
        metric_text.insert(END,line)
    metric_text.config(state=DISABLED)
    
def getnummber(original):
    global in_mm_inch,out_mm_inch
    input_unit = in_mm_inch.get()
    output_unit = out_mm_inch.get()
    dotpos=len(original)-4
    text = original[:dotpos] +'.' + original[dotpos:]
    num = float(text)
    if input_unit == "Inch" and output_unit == "Metric":
        nummetric = num *25.4
    if output_unit == "Inch" and input_unit == "Metric":
        nummetric = num /25.4
    if input_unit == output_unit:
        nummetric = num
    return str(nummetric)

def file_save():
    global g_code_code
    file_save = tkFileDialog.asksaveasfilename(title="NC-g_code-DATEI", \
    filetypes=[("EMC2 file",".ngc"),("NCFRS file",".nc"),("NC TAP",".tap"),\
    ("txt file",".txt"),("All files",".*")],initialfile="g_code")
    fobj = open(file_save, "w") 
    # hier brauch ich die liste g_code_code
    for line in g_code_code: 
        fobj.write(line) 
    fobj.close()

def my_split(s):
    res = [s]
    seps = ['X', 'Y', 'D']
    for sep in seps:
        s, res = res, []
        for seq in s:
            res += seq.split(sep)
    return res

def in_mm():
    in_mm_inch.set("Metric")
def in_inch():
    in_mm_inch.set("Inch")
def out_mm():
    out_mm_inch.set("Metric")
def out_inch():
    out_mm_inch.set("Inch")


def info():
    info_label_text.config(text='     GPL Sammel Lothar 2011          ' )
    info_label_text.update()    
    sleep(1)
    info_label_text.config(text='   Just SET Input and Output UNIT    ' )
    info_label_text.update()    
    sleep(1)
    info_label_text.config(text='Open the Gerber File and Save the GCode' )
    info_label_text.update()    
    sleep(1)
    info_label_text.config(text='INPUT <-- Set then open File --> OUTPUT')
    info_label_text.update()    
    
    
root = Tk()
 
# create a menu
menu = Menu(root)
root.config(menu=menu)
root.title('Gerber-TO-EMC_G-code Tool')
global in_mm_inch
in_mm_inch = StringVar()
in_mm_inch.set('Inch')
global out_mm_inch
out_mm_inch = StringVar()
out_mm_inch.set('Inch')

filemenu = Menu(menu)
menu.add_cascade(label="FILE", menu=filemenu)
filemenu.add_command(label="Open", command=file_open)
filemenu.add_command(label="Save", command=file_save)
filemenu.add_separator()
filemenu.add_command(label="Exit", command=programm_schliesen)

helpmenu = Menu(menu)
menu.add_cascade(label="Help", menu=helpmenu)
helpmenu.add_command(label="Info", command=info)

top_text = Label(root, bg="red", height=20)
top_text.pack(fill=X)
#gerber
b_in_mm = Button(top_text, text="MM", command=in_mm)
b_in_mm.pack(side=LEFT,ipadx=5,ipady=5,padx=5,pady=20)

gerber_label_text = Label(top_text,text='Gerber',bg='black',fg='white')
gerber_label_text.pack(side=LEFT,ipadx=5,ipady=5,padx=5,pady=20)

b_in_inch = Button(top_text, text="Inch", command=in_inch)
b_in_inch.pack(side=LEFT,ipadx=5,ipady=5,padx=5,pady=20)
in_label_text = Label(top_text,textvariable=in_mm_inch,bg='green',fg='Black')
in_label_text.pack(side=LEFT,ipadx=5,ipady=5,padx=5,pady=20)
#middle
info_label_text = Label(top_text,text='INPUT <-- Set then open File --> OUTPUT',bg='red',fg='black')
info_label_text.pack(side=LEFT,ipadx=5,ipady=5,padx=20,pady=20)
#g-code
out_label_text = Label(top_text,textvariable=out_mm_inch,bg='green',fg='Black')
out_label_text.pack(side=LEFT,ipadx=5,ipady=5,padx=5,pady=20)
b_out_mm = Button(top_text, text="MM", command=out_mm)
b_out_mm.pack(side=LEFT,ipadx=5,ipady=5,padx=5,pady=20)
g_code_label_text = Label(top_text,text='G-Code',bg='black',fg='white')
g_code_label_text.pack(side=LEFT,ipadx=5,ipady=5,padx=5,pady=20)
b_out_inch = Button(top_text, text="Inch", command=out_inch)
b_out_inch.pack(side=LEFT,ipadx=5,ipady=5,padx=5,pady=20)
# feeds
feed_z = IntVar()
feed_xy = IntVar()
feed_z.set(60)
feed_xy.set(200)
text = Label(top_text,text='Feed Z',bg='red',fg='black')
text.pack(side=LEFT,ipadx=1,ipady=5,padx=1,pady=20)
e_feed_z = Entry(top_text,textvariable=feed_z,width=4)
e_feed_z.pack(side=LEFT,ipadx=3,ipady=5,padx=1,pady=20)
text = Label(top_text,text='Feed XY',bg='red',fg='black')
text.pack(side=LEFT,ipadx=5,ipady=5,padx=5,pady=20)
e_feed_xy = Entry(top_text,textvariable=feed_xy,width=4)
e_feed_xy.pack(side=LEFT,ipadx=1,ipady=5,padx=1,pady=20)
# Z values
safe_z = StringVar()
depth = StringVar()
safe_z.set('5')
depth.set('-0.25')
text = Label(top_text,text='Z Safe',bg='red',fg='black')
text.pack(side=LEFT,ipadx=5,ipady=5,padx=1,pady=20)
e_safe_z = Entry(top_text,textvariable=safe_z,width=4)
e_safe_z.pack(side=LEFT,ipady=5)
text = Label(top_text,text='Z Depth',bg='red',fg='black')
text.pack(side=LEFT,ipadx=5,ipady=5,padx=1,pady=20)
e_depth = Entry(top_text,textvariable=depth,width=4)
e_depth.pack(side=LEFT,ipadx=1,ipady=5,padx=1,pady=20)
text = Label(top_text,text=' ',bg='red',fg='black')
text.pack(side=LEFT)

gerber_text=Text(root,state=DISABLED,bg='lightblue',fg='black',width=60)
gerber_text.pack(side=LEFT,ipadx=5)
#gerber_text.insert(END,'Gerber Code') 
metric_text=Text(root,state=DISABLED,bg='lightgreen',width=60)
metric_text.pack(side=RIGHT)
#metric_text.insert(END,'EMC2 G-Code') 
mainloop()
